- HTTP request
- Path parameters
- Query parameters
- Request body
- Response body
- Authorization Scopes
- IAM Permissions
Patches the specified BackendService resource with the data included in the request. There are several restrictions and guidelines to keep in mind when updating a backend service. Read Restrictions and Guidelines for more information. This method supports PATCH semantics and uses the JSON merge patch format and processing rules.
HTTP request
PATCH https://www.googleapis.com/compute/beta/projects/{project}/global/backendServices/{resourceId}
The URL uses gRPC Transcoding syntax.
Path parameters
| Parameters | |
|---|---|
project |
Project ID for this request. |
resourceId |
Name of the BackendService resource to patch. |
Query parameters
| Parameters | |
|---|---|
requestId |
An optional request ID to identify requests. Specify a unique request ID so that if you must retry your request, the server will know to ignore the request if it has already been completed. For example, consider a situation where you make an initial request and the request times out. If you make the request again with the same request ID, the server can check if original operation with the same request ID was received, and if so, will ignore the second request. This prevents clients from accidentally creating duplicate commitments. The request ID must be a valid UUID with the exception that zero UUID is not supported ( |
Request body
The request body contains data with the following structure:
| JSON representation | |
|---|---|
{ "id": string, "creationTimestamp": string, "name": string, "description": string, "selfLink": string, "backends": [ { "description": string, "group": string, "balancingMode": enum, "maxUtilization": number, "maxRate": number, "maxRatePerInstance": number, "maxRatePerEndpoint": number, "maxConnections": number, "maxConnectionsPerInstance": number, "maxConnectionsPerEndpoint": number, "capacityScaler": number, "failover": boolean } ], "healthChecks": [ string ], "timeoutSec": number, "port": number, "protocol": enum, "fingerprint": string, "portName": string, "enableCDN": boolean, "sessionAffinity": enum, "affinityCookieTtlSec": number, "region": string, "failoverPolicy": { "disableConnectionDrainOnFailover": boolean, "dropTrafficIfUnhealthy": boolean, "failoverRatio": number }, "loadBalancingScheme": enum, "connectionDraining": { "drainingTimeoutSec": number }, "iap": { "enabled": boolean, "oauth2ClientId": string, "oauth2ClientSecret": string, "oauth2ClientSecretSha256": string }, "cdnPolicy": { "cacheKeyPolicy": , "signedUrlKeyNames": [ string ], "signedUrlCacheMaxAgeSec": string }, "customRequestHeaders": [ string ], "securityPolicy": string, "logConfig": { "enable": boolean, "sampleRate": number }, "localityLbPolicy": enum, "consistentHash": { "httpCookie": , "httpHeaderName": string, "minimumRingSize": string }, "circuitBreakers": { "connectTimeout": , "maxRequestsPerConnection": number, "maxConnections": number, "maxPendingRequests": number, "maxRequests": number, "maxRetries": number }, "outlierDetection": { "consecutiveErrors": number, "interval": , "baseEjectionTime": , "maxEjectionPercent": number, "enforcingConsecutiveErrors": number, "enforcingSuccessRate": number, "successRateMinimumHosts": number, "successRateRequestVolume": number, "successRateStdevFactor": number, "consecutiveGatewayFailure": number, "enforcingConsecutiveGatewayFailure": number }, "kind": string } |
|
| Fields | |
|---|---|
id |
[Output Only] The unique identifier for the resource. This identifier is defined by the server. |
creationTimestamp |
[Output Only] Creation timestamp in RFC3339 text format. |
name |
Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression |
description |
An optional description of this resource. Provide this property when you create the resource. |
selfLink |
[Output Only] Server-defined URL for the resource. |
backends[] |
The list of backends that serve this BackendService. |
backends[].description |
An optional description of this resource. Provide this property when you create the resource. |
backends[].group |
The fully-qualified URL of an Instance Group or Network Endpoint Group resource. In case of instance group this defines the list of instances that serve traffic. Member virtual machine instances from each instance group must live in the same zone as the instance group itself. No two backends in a backend service are allowed to use same Instance Group resource. For Network Endpoint Groups this defines list of endpoints. All endpoints of Network Endpoint Group must be hosted on instances located in the same zone as the Network Endpoint Group. Backend service can not contain mix of Instance Group and Network Endpoint Group backends. Note that you must specify an Instance Group or Network Endpoint Group resource using the fully-qualified URL, rather than a partial URL. When the BackendService has load balancing scheme Authorization requires one or more of the following Google IAM permissions on the specified resource
|
backends[].balancingMode |
Specifies the balancing mode for this backend. For global HTTP(S) or TCP/SSL load balancing, the default is For Internal Load Balancing, the default and only supported mode is |
backends[].maxUtilization |
Used when This cannot be used for internal load balancing. |
backends[].maxRate |
The max requests per second (RPS) of the group. Can be used with either This cannot be used for internal load balancing. |
backends[].maxRatePerInstance |
The max requests per second (RPS) that a single backend instance can handle. This is used to calculate the capacity of the group. Can be used in either balancing mode. For This cannot be used for internal load balancing. |
backends[].maxRatePerEndpoint |
The max requests per second (RPS) that a single backend network endpoint can handle. This is used to calculate the capacity of the group. Can be used in either balancing mode. For This cannot be used for internal load balancing. |
backends[].maxConnections |
The max number of simultaneous connections for the group. Can be used with either This cannot be used for internal load balancing. |
backends[].maxConnectionsPerInstance |
The max number of simultaneous connections that a single backend instance can handle. This is used to calculate the capacity of the group. Can be used in either This cannot be used for internal load balancing. |
backends[].maxConnectionsPerEndpoint |
The max number of simultaneous connections that a single backend network endpoint can handle. This is used to calculate the capacity of the group. Can be used in either This cannot be used for internal load balancing. |
backends[].capacityScaler |
A multiplier applied to the group's maximum servicing capacity (based on This cannot be used for internal load balancing. |
backends[].failover |
This field designates whether this is a failover backend. More than one failover backend can be configured for a given BackendService. |
healthChecks[] |
The list of URLs to the HttpHealthCheck or HttpsHealthCheck resource for health checking this BackendService. Currently at most one health check can be specified, and a health check is required for Compute Engine backend services. A health check must not be specified for App Engine backend and Cloud Function backend. For internal load balancing, a URL to a HealthCheck resource must be specified instead. Authorization requires one or more of the following Google IAM permissions on the specified resource
|
timeoutSec |
How many seconds to wait for the backend before considering it a failed request. Default is 30 seconds. |
port |
Deprecated in favor of portName. The TCP port to connect on the backend. The default value is 80. This cannot be used for internal load balancing. |
protocol |
The protocol this BackendService uses to communicate with backends. Possible values are HTTP, HTTPS, TCP, and SSL. The default is HTTP. For internal load balancing, the possible values are TCP and UDP, and the default is TCP. |
fingerprint |
Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic locking. This field will be ignored when inserting a BackendService. An up-to-date fingerprint must be provided in order to update the To see the latest fingerprint, make a A base64-encoded string. |
portName |
Name of backend port. The same name should appear in the instance groups referenced by this service. Required when the load balancing scheme is When the load balancing scheme is |
enableCDN |
If true, enable Cloud CDN for this BackendService. When the load balancing scheme is |
sessionAffinity |
Type of session affinity to use. The default is NONE. When the load balancing scheme is When the load balancing scheme is When the protocol is |
affinityCookieTtlSec |
Lifetime of cookies in seconds if sessionAffinity is GENERATED_COOKIE. If set to 0, the cookie is non-persistent and lasts only until the end of the browser session (or equivalent). The maximum allowed value for TTL is one day. When the load balancing scheme is |
region |
[Output Only] URL of the region where the regional backend service resides. This field is not applicable to global backend services. You must specify this field as part of the HTTP request URL. It is not settable as a field in the request body. |
failoverPolicy |
|
failoverPolicy.disableConnectionDrainOnFailover |
On failover or failback, this field indicates whether connection drain will be honored. Setting this to true has the following effect: connections to the old active pool are not drained. Connections to the new active pool use the timeout of 10 min (currently fixed). Setting to false has the following effect: both old and new connections will have a drain timeout of 10 min. This can be set to true only if the protocol is TCP. The default is false. |
failoverPolicy.dropTrafficIfUnhealthy |
This option is used only when no healthy VMs are detected in the primary and backup instance groups. When set to true, traffic is dropped. When set to false, new connections are sent across all VMs in the primary group. The default is false. |
failoverPolicy.failoverRatio |
The value of the field must be in [0, 1]. If the ratio of the healthy VMs in the primary backend is at or below this number, traffic arriving at the load-balanced IP will be directed to the failover backend. In case where 'failoverRatio' is not set or all the VMs in the backup backend are unhealthy, the traffic will be directed back to the primary backend in the "force" mode, where traffic will be spread to the healthy VMs with the best effort, or to all VMs when no VM is healthy. This field is only used with l4 load balancing. |
loadBalancingScheme |
Indicates whether the backend service will be used with internal or external load balancing. A backend service created for one type of load balancing cannot be used with the other. Possible values are |
connectionDraining |
|
connectionDraining.drainingTimeoutSec |
Time for which instance will be drained (not accept new connections, but still work to finish started). |
iap |
|
iap.enabled |
|
iap.oauth2ClientId |
|
iap.oauth2ClientSecret |
|
iap.oauth2ClientSecretSha256 |
[Output Only] SHA256 hash value for the field oauth2ClientSecret above. |
cdnPolicy |
Cloud CDN configuration for this BackendService. |
cdnPolicy.cacheKeyPolicy |
The CacheKeyPolicy for this CdnPolicy. |
cdnPolicy.cacheKeyPolicy.includeProtocol |
If true, http and https requests will be cached separately. |
cdnPolicy.cacheKeyPolicy.includeHost |
If true, requests to different hosts will be cached separately. |
cdnPolicy.cacheKeyPolicy.includeQueryString |
If true, include query string parameters in the cache key according to queryStringWhitelist and queryStringBlacklist. If neither is set, the entire query string will be included. If false, the query string will be excluded from the cache key entirely. |
cdnPolicy.cacheKeyPolicy.queryStringWhitelist[] |
Names of query string parameters to include in cache keys. All other parameters will be excluded. Either specify queryStringWhitelist or queryStringBlacklist, not both. '&' and '=' will be percent encoded and not treated as delimiters. |
cdnPolicy.cacheKeyPolicy.queryStringBlacklist[] |
Names of query string parameters to exclude in cache keys. All other parameters will be included. Either specify queryStringWhitelist or queryStringBlacklist, not both. '&' and '=' will be percent encoded and not treated as delimiters. |
cdnPolicy.signedUrlKeyNames[] |
[Output Only] Names of the keys for signing request URLs. |
cdnPolicy.signedUrlCacheMaxAgeSec |
Maximum number of seconds the response to a signed URL request will be considered fresh. After this time period, the response will be revalidated before being served. Defaults to 1hr (3600s). When serving responses to signed URL requests, Cloud CDN will internally behave as though all responses from this backend had a |
customRequestHeaders[] |
Headers that the HTTP/S load balancer should add to proxied requests. |
securityPolicy |
[Output Only] The resource URL for the security policy associated with this backend service. |
logConfig |
This field denotes the logging options for the load balancer traffic served by this backend service. If logging is enabled, logs will be exported to Stackdriver. |
logConfig.enable |
This field denotes whether to enable logging for the load balancer traffic served by this backend service. |
logConfig.sampleRate |
This field can only be specified if logging is enabled for this backend service. The value of the field must be in [0, 1]. This configures the sampling rate of requests to the load balancer where 1.0 means all logged requests are reported and 0.0 means no logged requests are reported. The default value is 1.0. |
localityLbPolicy |
The load balancing algorithm used within the scope of the locality. The possible values are:
This field is applicable to either: |
consistentHash |
Consistent Hash-based load balancing can be used to provide soft session affinity based on HTTP headers, cookies or other properties. This load balancing policy is applicable only for HTTP connections. The affinity to a particular destination host will be lost when one or more hosts are added/removed from the destination service. This field specifies parameters that control consistent hashing. This field is only applicable when This field is applicable to either:
|
consistentHash.httpCookie |
Hash is based on HTTP Cookie. This field describes a HTTP cookie that will be used as the hash key for the consistent hash load balancer. If the cookie is not present, it will be generated. This field is applicable if the |
consistentHash.httpCookie.name |
Name of the cookie. |
consistentHash.httpCookie.path |
Path to set for the cookie. |
consistentHash.httpCookie.ttl |
Lifetime of the cookie. |
consistentHash.httpCookie.ttl.seconds |
Span of time at a resolution of a second. Must be from 0 to 315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
consistentHash.httpCookie.ttl.nanos |
Span of time that's a fraction of a second at nanosecond resolution. Durations less than one second are represented with a 0 |
consistentHash.httpHeaderName |
The hash based on the value of the specified header field. This field is applicable if the |
consistentHash.minimumRingSize |
The minimum number of virtual nodes to use for the hash ring. Defaults to 1024. Larger ring sizes result in more granular load distributions. If the number of hosts in the load balancing pool is larger than the ring size, each host will be assigned a single virtual node. |
circuitBreakers |
Settings controlling the volume of connections to a backend service. This field is applicable to either:
|
circuitBreakers.connectTimeout |
The timeout for new network connections to hosts. |
circuitBreakers.connectTimeout.seconds |
Span of time at a resolution of a second. Must be from 0 to 315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
circuitBreakers.connectTimeout.nanos |
Span of time that's a fraction of a second at nanosecond resolution. Durations less than one second are represented with a 0 |
circuitBreakers.maxRequestsPerConnection |
Maximum requests for a single backend connection. This parameter is respected by both the HTTP/1.1 and HTTP/2 implementations. If not specified, there is no limit. Setting this parameter to 1 will effectively disable keep alive. |
circuitBreakers.maxConnections |
The maximum number of connections to the backend cluster. If not specified, the default is 1024. |
circuitBreakers.maxPendingRequests |
The maximum number of pending requests allowed to the backend cluster. If not specified, the default is 1024. |
circuitBreakers.maxRequests |
The maximum number of parallel requests that allowed to the backend cluster. If not specified, the default is 1024. |
circuitBreakers.maxRetries |
The maximum number of parallel retries allowed to the backend cluster. If not specified, the default is 3. |
outlierDetection |
Settings controlling eviction of unhealthy hosts from the load balancing pool. This field is applicable to either:
|
outlierDetection.consecutiveErrors |
Number of errors before a host is ejected from the connection pool. When the backend host is accessed over HTTP, a 5xx return code qualifies as an error. Defaults to 5. |
outlierDetection.interval |
Time interval between ejection sweep analysis. This can result in both new ejections as well as hosts being returned to service. Defaults to 10 seconds. |
outlierDetection.interval.seconds |
Span of time at a resolution of a second. Must be from 0 to 315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
outlierDetection.interval.nanos |
Span of time that's a fraction of a second at nanosecond resolution. Durations less than one second are represented with a 0 |
outlierDetection.baseEjectionTime |
The base time that a host is ejected for. The real time is equal to the base time multiplied by the number of times the host has been ejected. Defaults to 30000ms or 30s. |
outlierDetection.baseEjectionTime.seconds |
Span of time at a resolution of a second. Must be from 0 to 315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
outlierDetection.baseEjectionTime.nanos |
Span of time that's a fraction of a second at nanosecond resolution. Durations less than one second are represented with a 0 |
outlierDetection.maxEjectionPercent |
Maximum percentage of hosts in the load balancing pool for the backend service that can be ejected. Defaults to 10%. |
outlierDetection.enforcingConsecutiveErrors |
The percentage chance that a host will be actually ejected when an outlier status is detected through consecutive 5xx. This setting can be used to disable ejection or to ramp it up slowly. Defaults to 100. |
outlierDetection.enforcingSuccessRate |
The percentage chance that a host will be actually ejected when an outlier status is detected through success rate statistics. This setting can be used to disable ejection or to ramp it up slowly. Defaults to 100. |
outlierDetection.successRateMinimumHosts |
The number of hosts in a cluster that must have enough request volume to detect success rate outliers. If the number of hosts is less than this setting, outlier detection via success rate statistics is not performed for any host in the cluster. Defaults to 5. |
outlierDetection.successRateRequestVolume |
The minimum number of total requests that must be collected in one interval (as defined by the interval duration above) to include this host in success rate based outlier detection. If the volume is lower than this setting, outlier detection via success rate statistics is not performed for that host. Defaults to 100. |
outlierDetection.successRateStdevFactor |
This factor is used to determine the ejection threshold for success rate outlier ejection. The ejection threshold is the difference between the mean success rate, and the product of this factor and the standard deviation of the mean success rate: mean - (stdev * successRateStdevFactor). This factor is divided by a thousand to get a double. That is, if the desired factor is 1.9, the runtime value should be 1900. Defaults to 1900. |
outlierDetection.consecutiveGatewayFailure |
The number of consecutive gateway failures (502, 503, 504 status or connection errors that are mapped to one of those status codes) before a consecutive gateway failure ejection occurs. Defaults to 5. |
outlierDetection.enforcingConsecutiveGatewayFailure |
The percentage chance that a host will be actually ejected when an outlier status is detected through consecutive gateway failures. This setting can be used to disable ejection or to ramp it up slowly. Defaults to 0. |
kind |
[Output Only] Type of resource. Always |
Response body
If successful, the response body contains data with the following structure:
| JSON representation | |
|---|---|
{ "id": string, "creationTimestamp": string, "name": string, "zone": string, "clientOperationId": string, "operationType": string, "targetLink": string, "targetId": string, "status": enum, "statusMessage": string, "user": string, "progress": number, "insertTime": string, "startTime": string, "endTime": string, "error": { "errors": [ { "code": string, "location": string, "message": string } ] }, "warnings": [ { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } ], "httpErrorStatusCode": number, "httpErrorMessage": string, "selfLink": string, "region": string, "description": string, "kind": string } |
|
| Fields | |
|---|---|
id |
[Output Only] The unique identifier for the resource. This identifier is defined by the server. |
creationTimestamp |
[Deprecated] This field is deprecated. |
name |
[Output Only] Name of the resource. |
zone |
[Output Only] The URL of the zone where the operation resides. Only applicable when performing per-zone operations. |
clientOperationId |
[Output Only] The value of |
operationType |
[Output Only] The type of operation, such as |
targetLink |
[Output Only] The URL of the resource that the operation modifies. For operations related to creating a snapshot, this points to the persistent disk that the snapshot was created from. |
targetId |
[Output Only] The unique target ID, which identifies a specific incarnation of the target resource. |
status |
[Output Only] The status of the operation, which can be one of the following: |
statusMessage |
[Output Only] An optional textual description of the current status of the operation. |
user |
[Output Only] User who requested the operation, for example: |
progress |
[Output Only] An optional progress indicator that ranges from 0 to 100. There is no requirement that this be linear or support any granularity of operations. This should not be used to guess when the operation will be complete. This number should monotonically increase as the operation progresses. |
insertTime |
[Output Only] The time that this operation was requested. This value is in RFC3339 text format. |
startTime |
[Output Only] The time that this operation was started by the server. This value is in RFC3339 text format. |
endTime |
[Output Only] The time that this operation was completed. This value is in RFC3339 text format. |
error |
[Output Only] If errors are generated during processing of the operation, this field will be populated. |
error.errors[] |
[Output Only] The array of errors encountered while processing this operation. |
error.errors[].code |
[Output Only] The error type identifier for this error. |
error.errors[].location |
[Output Only] Indicates the field in the request that caused the error. This property is optional. |
error.errors[].message |
[Output Only] An optional, human-readable error message. |
warnings[] |
[Output Only] If warning messages are generated during processing of the operation, this field will be populated. |
warnings[].code |
[Output Only] A warning code, if applicable. For example, Compute Engine returns |
warnings[].message |
[Output Only] A human-readable description of the warning code. |
warnings[].data[] |
[Output Only] Metadata about this warning in "data": [ { "key": "scope", "value": "zones/us-east1-d" }
|
warnings[].data[].key |
[Output Only] A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be |
warnings[].data[].value |
[Output Only] A warning data value corresponding to the key. |
httpErrorStatusCode |
[Output Only] If the operation fails, this field contains the HTTP error status code that was returned. For example, a |
httpErrorMessage |
[Output Only] If the operation fails, this field contains the HTTP error message that was returned, such as |
selfLink |
[Output Only] Server-defined URL for the resource. |
region |
[Output Only] The URL of the region where the operation resides. Only applicable when performing regional operations. |
description |
[Output Only] A textual description of the operation, which is set when the operation is created. |
kind |
[Output Only] Type of the resource. Always |
Authorization Scopes
Requires one of the following OAuth scopes:
https://www.googleapis.com/auth/computehttps://www.googleapis.com/auth/cloud-platform
For more information, see the Authentication Overview.
IAM Permissions
In addition to any permissions specified on the fields above, authorization requires one or more of the following Google IAM permissions:
compute.backendServices.getcompute.backendServices.update
To find predefined roles that contain those permissions, see Compute Engine IAM Roles.


